<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f6e344e3a1998_00984538/operators/FlowchartOperator_lb5f6e344e3a1998_00984538.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f6e344e3a1998_00984538/helpers/DateTimeConverter_lb5f6e344e3a1998_00984538.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f6e344e3a1998_00984538/helpers/DecimalConverter_lb5f6e344e3a1998_00984538.php';

class GetEntityAttributesOperator_lb5f6e344e3a1998_00984538_op2 extends FlowchartOperator_lb5f6e344e3a1998_00984538{

    protected $entityName;
    protected $emptyEntity;

    protected $entity;
    protected $attributes = array();

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        $this->setEntityName($params['inDataPorts']['entity']['value']);

        $this->inDataPorts = array();
        foreach($params['inDataPorts'] as $key => $value)
            if($key == 'entity')
                $this->inDataPorts[$key]['id'] = $value['id'];
            else
                $this->inDataPorts[$key] = $value;
    }

    protected function setEntityName($moduleName){
        $this->entityName = $moduleName; //$beanList[$moduleName];
    }

    public function setInDataPortById($id, $value){
        if($id == 'entity'){
            $this->entity = $value;
        }else
            parent::setInDataPortById($id, $value);
    }

    public function process($params = array()){
        $this->initOutDataPortsWithAttr();
    }

    protected function initOutDataPortsWithAttr(){
        $this->checkCurrentAttrValue('name');
        if(isset($this->entity->name)){
            $this->attributes['name'] = $this->convertAttrValue('name', $this->entity->name);
        }else{
            $this->attributes['name'] = NULL;
        }
        $this->checkCurrentAttrValue('description');
        if(isset($this->entity->description)){
            $this->attributes['description'] = $this->convertAttrValue('description', $this->entity->description);
        }else{
            $this->attributes['description'] = NULL;
        }
        $this->checkCurrentAttrValue('case_number');
        if(isset($this->entity->case_number)){
            $this->attributes['case_number'] = $this->convertAttrValue('case_number', $this->entity->case_number);
        }else{
            $this->attributes['case_number'] = NULL;
        }
        $this->checkCurrentAttrValue('assigned_user_id');
        if(isset($this->entity->assigned_user_id)){
            $this->attributes['assigned_user_id'] = $this->convertAttrValue('assigned_user_id', $this->entity->assigned_user_id);
        }else{
            $this->attributes['assigned_user_id'] = NULL;
        }
        $this->checkCurrentAttrValue('account_id');
        if(isset($this->entity->account_id)){
            $this->attributes['account_id'] = $this->convertAttrValue('account_id', $this->entity->account_id);
        }else{
            $this->attributes['account_id'] = NULL;
        }
    }

    public function getOutDataByPortId($portId){
        $field = $this->outDataPorts[$portId]['value'];
        return $this->attributes[$field];
    }

    protected function convertAttrValue($fieldName, $fieldValue){

        if($this->entity instanceof SugarBean){
            if(!empty($this->entity->field_defs[$fieldName])){
                $fieldDef = $this->entity->field_defs[$fieldName];
            }
        }else{
            if(empty($this->emptyEntity)){
                $this->emptyEntity = BeanFactory::getBean($this->entityName);
            }

            if(!empty($this->emptyEntity->field_defs[$fieldName])){
                $fieldDef = $this->emptyEntity->field_defs[$fieldName];
            }
        }

        if(empty($fieldDef))
            return $fieldValue;

        switch($fieldDef['type']){
            case 'date':
            case 'datetime':
            case 'datetimecombo':
                require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f6e344e3a1998_00984538/helpers/DateTimeConverter_lb5f6e344e3a1998_00984538.php';
                $fieldValue = DateTimeConverter_lb5f6e344e3a1998_00984538::convertToDisplay($fieldDef, $fieldValue);
                break;
            case 'currency':
            case 'decimal':
            case 'double':
            case 'float':
                require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f6e344e3a1998_00984538/helpers/DecimalConverter_lb5f6e344e3a1998_00984538.php';
                $fieldValue = DecimalConverter_lb5f6e344e3a1998_00984538::convertToDisplay($fieldDef, $fieldValue);
                break;
            case 'integer':
            case 'int':
                break;
            default:
                if(empty($fieldValue)){
                    $fieldValue = NULL;
                }
                break;
        }

        return $fieldValue;
    }

    protected function checkCurrentAttrValue($fieldName){
        if($fieldName == 'date_entered' && $this->entity instanceof SugarBean &&
            empty($this->entity->date_entered) && !empty($this->entity->fetched_row['date_entered'])){
            $this->entity->date_entered = $this->entity->fetched_row['date_entered'];
        }
    }

}
