<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f6e344e3a1998_00984538/operators/FlowchartOperator_lb5f6e344e3a1998_00984538.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f6e344e3a1998_00984538/helpers/rest/RestHelper_lb5f6e344e3a1998_00984538.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb5f6e344e3a1998_00984538/helpers/rest/OAuth2AuthHelper_lb5f6e344e3a1998_00984538.php';

class RestClientOperator_lb5f6e344e3a1998_00984538 extends FlowchartOperator_lb5f6e344e3a1998_00984538{

    protected $url;
    protected $method;
    protected $headers;
    protected $parameters;
    protected $authentication;
    protected $proxy;

    protected $info = array();
    protected $response = array();

    public function __construct($params){
        parent::__construct($params);
    }

    public function setInDataPorts($params){
        parent::setInDataPorts($params);

        if(!empty($this->inDataPorts['url']['value']))
            $this->url = $this->inDataPorts['url']['value'];
        if(!empty($this->inDataPorts['httpMethod']['value']))
            $this->method = $this->inDataPorts['httpMethod']['value'];
    }

    public function setInDataPortById($id, $value){
        if($id == 'url')
            $this->url = $value;
        if($id == 'httpMethod')
            $this->method = $value;
        if($id == 'headers')
            $this->headers = $value;
        if($id == 'queryParameters')
            $this->parameters = $value;
        if($id == 'authentication')
            $this->authentication = $value;
        if($id == 'proxy')
            $this->proxy = $value;
    }

    public function process($params = array()){
        $curlAuth = '';

        if(empty($this->headers['oauth-token']) && !empty($this->authentication)){
            if($this->authentication instanceof OAuth2AuthHelper_lb5f6e344e3a1998_00984538){
                $authParams = array();
                if(!empty($this->proxy))
                    $authParams['proxy'] = $this->proxy;

                if(($authHttpCode = $this->authentication->authenticate($authParams)) == 200){
                    $outh_token = $this->authentication->getToken();
                    if(!empty($outh_token)){
                        $this->headers['oauth-token'] = $outh_token;
                    }
                }
            }elseif(is_array($this->authentication)){
                if(!empty($this->authentication['access_token']))
                    $this->headers['oauth-token'] = $this->authentication['access_token'];
                elseif(!empty($this->authentication['username']) && !empty($this->authentication['password']))
                    $curlAuth = $this->authentication;

            }

        }
        //$GLOBALS['log']->fatal('HEADERS: ' . print_r($this->headers, true));

        if(!empty($this->authentication) && $this->authentication instanceof OAuth2AuthHelper_lb5f6e344e3a1998_00984538 && $authHttpCode != 200){
            $this->info['http_code'] = $authHttpCode;
        }else{
            $response = RestHelper_lb5f6e344e3a1998_00984538::call(
                    $this->url,
                    $this->method,
                    $this->headers,
                    $this->parameters,
                    $this->proxy,
                    $curlAuth
                );

            if(isset($response['result'])){
                $this->response = $response['result'];
//				if(!empty($response['info']['content_type']) && $response['info']['content_type'] == 'application/json'){
//					$this->response = json_decode($response['result'], true);
//					if(json_last_error() != JSON_ERROR_NONE)
//						$this->response = $response['result'];
//				}
			}
            if(isset($response['info'])){
                $this->info = $response['info'];
            }
        }
    }

    public function getOutDataByPortId($portId){
        if($portId == 'response')
            return $this->response;
        elseif($portId == 'httpCode')
            return !empty($this->info['http_code']) ? $this->info['http_code'] : '';

        return '';
    }
}
